config {
    merged_exchange {
        -- source_id of master exchange
        source_id     = 966,
        name          = 'equity-l1-spain',

        match {
            subject_pattern = "(.+):(?:966|216)",
        },

        add_fields {
            RDN_EXCHID     = 2,
            PROD_PERM      = 966,
            RDNDISPLAY     = 125,
            RDN_EXCHID     = enum_def_lookup("MAD"),
        },

        field_mapping {
            ["ACTIVITY.DATETIME"]  = "ignore",
            ["TRADE.PRICE"]        = "ignore",
            ["CURRENT.PRICE"]      = "ignore",
            ["SETTLE.DATE"]        = "ignore",
            ["PREV.TRADE.DATE"]    = "ignore",
        },

        -- exchanges to merge into this one
        exchange {
            source_id     = 216,
            field_mapping {
                -- ignore fields present on both exchanges from 216
                ["CHG"]                = "ignore",
                -- sometimes this isn't present on 966
                -- ["CURRENT.PRICE"]      = "ignore",
                ["DISPLAY.PRECISION"]  = "ignore",
                ["CURRENT.PRICE"]      = "ignore",
                ["ENUM.CURRENCY"]      = "ignore",
                ["ENUM.INSTR.TYPE"]    = "ignore",
                ["INSTR_NAME2"]        = "ignore",
                ["ISIN"]               = "ignore",
                ["SEDOL"]              = "ignore",
                ["PCT.CHG"]            = "ignore",
                ["SETTLE.DATE"]        = "GV1_DATE",
                ["PREV.TRADE.DATE"]    = "ignore",
                ["YEST.TRADE.CLOSE"]   = "ignore",
            },
        },
    },
}
